// MDSimulation.cpp: implementation of the MDSimulation class.
//
//////////////////////////////////////////////////////////////////////

#include "MDSimulation.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
// XXX #define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MDSimulation::MDSimulation()
{
	atoms = new Atoms();
	nonOverlapRandom = new RandomPositionStrategy(1.0, &rand);
	thermalize = new ThermalizeVelocityStrategy(1.0, &rand);
	double dt=0.01;
	timeStepsBetweenObservations = 1;
	update = new UpdateStrategy(dt);
}

MDSimulation::~MDSimulation()
{
	delete atoms;
	delete nonOverlapRandom;
	delete thermalize;
	delete update;
}
