// MDSimulation.h: interface for the MDSimulation class.
//
//////////////////////////////////////////////////////////////////////

#ifndef MDSIMULATION_H
#define MDSIMULATION_H

#include "Atoms.h"	// Added by ClassView
#include "ThermalizeVelocityStrategy.h"	// Added by ClassView
#include "UpdateStrategy.h"	// Added by ClassView
#include "RandomPositionStrategy.h"	// Added by ClassView
#include "Rand.h"	// Added by ClassView

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif // SWIG

class MDSimulation  
{
public:
	Rand rand;
	RandomPositionStrategy *nonOverlapRandom;
	UpdateStrategy *update;
	ThermalizeVelocityStrategy *thermalize;
	Atoms *atoms;
	int timeStepsBetweenObservations;
	MDSimulation();
	virtual ~MDSimulation();

};

#endif // !defined(MDSIMULATION_H)
