// RandomPositionStrategy.cpp: implementation of the RandomPositionStrategy class.
//
//////////////////////////////////////////////////////////////////////

#include "RandomPositionStrategy.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RandomPositionStrategy::RandomPositionStrategy(double distanceMin, 
//	*((std::vector<int>) neighbors()), Rand *rand)
	Rand *rand)
{
	SetDistanceMin(distanceMin);
	this->rand = rand;
}

RandomPositionStrategy::~RandomPositionStrategy()
{

}


void RandomPositionStrategy::Move(Atoms *atoms)
{
	int i;	// Microsoft conventions for declaring i in loop not standard

	for (i=0; i<atoms->Number(); i++)
	{
		for (int coord=0; coord<DIMENSION; coord++)
		atoms->SetX(i, coord, atoms->BoxSize()[coord]*rand->uniform());
	}

	for (i=0; i<atoms->Number(); i++)
	{
		while (int x = atoms->NumNeighbors(distance2Min,i)>0)
		{
			for (int coord=0; coord<DIMENSION; coord++)
				atoms->SetX(i, coord, atoms->BoxSize()[coord]*rand->uniform());
		}
	}
}
