// RandomPositionStrategy.h: interface for the RandomPositionStrategy class.
//
//////////////////////////////////////////////////////////////////////

// Generates atoms separated by more than distanceMin
// We recommend keeping distanceMin > sqrt(width*height/(2*atoms.num)) 
// or the algorithm is not guaranteed ever to converge

#ifndef RANDOMPOSITIONSTRATEGY_H
#define RANDOMPOSITIONSTRATEGY_H

// Not compatible with Python? #if _MSC_VER >= 1000
// Not compatible with Python? #pragma once
// Not compatible with Python? #endif // _MSC_VER >= 1000

#include "AtomStrategy.h"
#include "Rand.h"

class RandomPositionStrategy : public AtomStrategy
{
public:
	RandomPositionStrategy(double distanceMin, Rand *rand);
	virtual ~RandomPositionStrategy();
	virtual void Move(Atoms *atoms);
	void SetDistanceMin(double distanceMin) {this->distance2Min = distanceMin*distanceMin;}

protected:
	double distance2Min;
	Rand *rand;

};

#endif // !defined(RANDOMPOSITIONSTRATEGY_H)
