// ThermalizeVelocityStrategy.cpp: implementation of the ThermalizeVelocityStrategy class.
//
//////////////////////////////////////////////////////////////////////

#include "ThermalizeVelocityStrategy.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ThermalizeVelocityStrategy::ThermalizeVelocityStrategy(double temperature, Rand *rand)
{
	this->temperature = temperature;
	this->rand = rand;
}

ThermalizeVelocityStrategy::~ThermalizeVelocityStrategy()
{

}


void ThermalizeVelocityStrategy::Move(Atoms *atoms)
{
	double sig = sqrt(temperature);

	for (int i=0; i<atoms->Number(); i++)
	{
		for (int j=0; j<DIMENSION; j++)
		{
			atoms->SetV(i, j, rand->gaussian(sig));
		}
	}
}
