// ThermalizeVelocityStrategy.h: interface for the ThermalizeVelocityStrategy class.
//
//////////////////////////////////////////////////////////////////////

#ifndef THERMALIZEVELOCITYSTRATEGY_H
#define THERMALIZEVELOCITYSTRATEGY_H

#ifndef SWIG
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#endif

#include "AtomStrategy.h"
#include "Atoms.h"	// Added by ClassView
#include "Rand.h"

class ThermalizeVelocityStrategy : public AtomStrategy 
{
public:
	ThermalizeVelocityStrategy(double temperature, Rand * rand);
	virtual ~ThermalizeVelocityStrategy();
	virtual void Move(Atoms *atoms);
	double GetTemperature() const {return temperature;}
	void SetTemperature(double temperature)
		{this->temperature = temperature;}

protected:
	double temperature;
	Rand *rand;

};

#endif // !defined(THERMALIZEVELOCITYSTRATEGY_H)
