// UpdateStrategy.cpp: implementation of the UpdateStrategy class.
//
//////////////////////////////////////////////////////////////////////

#include "UpdateStrategy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

UpdateStrategy::UpdateStrategy(double dt)
{
	this->dt = dt;
}

UpdateStrategy::~UpdateStrategy()
{

}

void UpdateStrategy::Move(Atoms *atoms)
{
	int i;

	// Update positions by dt/2
	for (i=0; i<atoms->Number(); i++)
	{
		for (int coord=0; coord<DIMENSION; coord++)
			atoms->SetX(i, coord, atoms->X(i,coord) + 0.5*dt*atoms->V(i, coord));
	}

}
