// MDDoc.cpp : implementation of the CMDDoc class
//

#include "stdafx.h"
#include "MD.h"

#include "MDDoc.h"
#include "MDParameterDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMDDoc

IMPLEMENT_DYNCREATE(CMDDoc, CDocument)

BEGIN_MESSAGE_MAP(CMDDoc, CDocument)
	//{{AFX_MSG_MAP(CMDDoc)
	ON_COMMAND(ID_PARAMETERS_SETPARAMETERS, OnParamChange)
	ON_COMMAND(ID_BUTTON32772, OnParamChange)
	ON_COMMAND(ID_BUTTON32773, OnThermalize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMDDoc construction/destruction

CMDDoc::CMDDoc()
{
	pauseThread = false;
}

CMDDoc::~CMDDoc()
{
}

BOOL CMDDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMDDoc serialization

void CMDDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMDDoc diagnostics

#ifdef _DEBUG
void CMDDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMDDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMDDoc commands

void CMDDoc::OnParamChange() 
{
	MDParameterDialog dialog_box;

	dialog_box.m_numberAtoms = sim.atoms->Number();
	dialog_box.m_dt = sim.update->GetDt();		dialog_box.m_temperature = sim.thermalize->GetTemperature();
	dialog_box.m_timeStepsBetweenObservations = sim.timeStepsBetweenObservations;
	if (dialog_box.DoModal() == IDOK)
	{
		// Lock thread while parameters are changing

		pauseThread = true;
		threadPaused.Lock();	// Wait for thread to pause
		threadPaused.Unlock();	// Silly Microsoft convention

		if (dialog_box.m_numberAtoms != sim.atoms->Number())
		{
			sim.atoms->SetNumber(dialog_box.m_numberAtoms);
			sim.nonOverlapRandom->Move(sim.atoms);
			sim.thermalize->Move(sim.atoms);
		}
		if (dialog_box.m_dt != sim.update->GetDt())
		{
			sim.update->SetDt(dialog_box.m_dt);
		}
		if (dialog_box.m_temperature != sim.thermalize->GetTemperature())
		{
			sim.thermalize->SetTemperature(dialog_box.m_temperature);
			sim.thermalize->Move(sim.atoms);
		}
		if (dialog_box.m_timeStepsBetweenObservations != sim.timeStepsBetweenObservations)
		{
			sim.timeStepsBetweenObservations = dialog_box.m_timeStepsBetweenObservations;
		}
		paramsChanged.SetEvent();	// Restart thread
	}
}

void CMDDoc::OnThermalize()
{
	// Lock thread while parameters are changing

	pauseThread = true;
	threadPaused.Lock();	// Wait for thread to pause
	threadPaused.Unlock();	// Silly Microsoft convention

	sim.thermalize->Move(sim.atoms);
	paramsChanged.SetEvent();	// Restart thread
}
