// MDDoc.h : interface of the CMDDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MDDOC_H__58233451_A1C3_11D2_9106_00A0C9B3BAEA__INCLUDED_)
#define AFX_MDDOC_H__58233451_A1C3_11D2_9106_00A0C9B3BAEA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Atoms.h"
#include "MDSimulation.h"
#include <afxmt.h>	// for locking

class CMDDoc : public CDocument
{
protected: // create from serialization only
	CMDDoc();
	DECLARE_DYNCREATE(CMDDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	MDSimulation sim;
	virtual ~CMDDoc();
	volatile bool pauseThread;
	CEvent threadPaused;		// Signal causes thread to pause while params are changed
	CEvent paramsChanged;		// Announces finish of params change so thread can restart


#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMDDoc)
	afx_msg void OnParamChange();
	afx_msg void OnThermalize();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MDDOC_H__58233451_A1C3_11D2_9106_00A0C9B3BAEA__INCLUDED_)
