// MDView.h : interface of the CMDView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MDVIEW_H__58233453_A1C3_11D2_9106_00A0C9B3BAEA__INCLUDED_)
#define AFX_MDVIEW_H__58233453_A1C3_11D2_9106_00A0C9B3BAEA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afxmt.h>	// for locking

class CMDView : public CView
{
protected: // create from serialization only
	CMDView();
	DECLARE_DYNCREATE(CMDView)

// Attributes
public:
	CMDDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void AtomsMoved(double t);
	virtual ~CMDView();
	volatile bool stopThread;	// Communicates between threads, so MUST BE volatile
	CEvent threadDone;			// Allows thread to announce exit to main loop

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// From Matt Kuntz's program, Spring 1998
	double dX, dY;
	int window_width, window_height;
	CDC bufferDC;
	CDC *stored_pDC;		// For AtomsMoved (later Update): don't get new device context each draw!
	CBitmap *buffer;
	CBitmap *oldBuffer;

// Generated message map functions
protected:
	//{{AFX_MSG(CMDView)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MDView.cpp
inline CMDDoc* CMDView::GetDocument()
   { return (CMDDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MDVIEW_H__58233453_A1C3_11D2_9106_00A0C9B3BAEA__INCLUDED_)
